from __future__ import annotations
from typing import Any, Union
from typing_extensions import Self


class SmallInt:
    """Represent SmallInt in PostgreSQL and `i16` in Rust."""

    def __init__(self: Self, inner_value: int) -> Self:
        """Create new instance of class.
        
        ### Parameters:
        - `inner_value`: int object.
        """


class Integer:
    """Represent Integer in PostgreSQL and `i32` in Rust."""

    def __init__(self: Self, inner_value: int) -> Self:
        """Create new instance of class.
        
        ### Parameters:
        - `inner_value`: int object.
        """


class BigInt:
    """Represent BigInt in PostgreSQL and `i64` in Rust."""

    def __init__(self: Self, inner_value: int) -> Self:
        """Create new instance of class.
        
        ### Parameters:
        - `inner_value`: int object.
        """


class PyUUID:
    """Represent UUID in PostgreSQL and Uuid in Rust."""

    def __init__(self: Self, inner_value: str) -> Self:
        """Create new instance of class.

        You need to pass uuid as a str.
        
        ### Parameters:
        - `inner_value`: str object.
        """


class PyJSON:
    """Represent JSON/JSONB field in PostgreSQL and Value in Rust."""
    
    def __init__(
        self: Self,
        value: Union[
            dict[str, Any],
            list[dict[str, Any]],
            list[Any],
        ],
    ) -> None:
        """Create new instance of PyJSON.

        It accepts structure that can be used in JSON/JSONB fields.

        ### Parameters:
        - `value`: value for the JSON/JSONB field.
        """
